/* Programme pour tester le bon fonctionnement de l'afficheur OLED.
   Se contente d'afficher la valeur angulaire des divers moteurs.
   Ces valeurs sont initialisées arbitrairement dans void setup() pour valider l'affichage.
   SDA est branché sur A4.
   SCL est branché sur A5
        Programme : 7502 octets 24%
Mémoire dynamique :  318 octets 15%

NOTE : Bien que les valeurs angulaires passées à Affiche_valeur_angulaire() sont codées
       sur un char, pour gérer les négatifs, le paramètre de la procédure est un int
       pour gérer facilement l'affichage de valeurs négatives.
       
                                                                PGM               RAM dynamique
 PGM de dialogue sur la ligne série.                    8138 Octets (26%)      335 Octets (16%)    */

//--------------------------- Variables du programme ---------------------------
boolean Ouverte;
char Coude, Epaule, Hanche;

#include "U8glib.h"

U8GLIB_SH1106_128X64 u8g(U8G_I2C_OPT_NONE);	// Usage de la ligne I2C (Two Wire Interface)

void setup() {Coude = -8; Epaule = 7; Hanche = -45;}

void loop() {PAGE1(); Ouverte = !Ouverte; delay(2000);}
  
void PAGE1() {
  u8g.setFont(u8g_font_6x10); // Pocice de matrices de 6x10 pixels lettres MJA/min comprises.
  u8g.firstPage(); do {// Début de la boucle d'affichage de la page écran.
  //------------------------------------------------------------------
  CADRES();
  Aff_TEXTE(11, 9 ,"Etat motorisation.");
  Aff_TEXTE(5,24,"  PINCE :"); if (Ouverte) Aff_TEXTE(72,24,"Ouverte"); else  Aff_TEXTE(72,23,"Fermee");
  Aff_TEXTE(5,35,"  COUDE :"); u8g.setPrintPos(60, 35); Affiche_valeur_angulaire(Coude);
  Aff_TEXTE(5,45," EPAULE :"); u8g.setPrintPos(60, 45); Affiche_valeur_angulaire(Epaule);
  Aff_TEXTE(5,55," HANCHE :"); u8g.setPrintPos(60, 55); Affiche_valeur_angulaire(Hanche);}
  //====================================================================
  while(u8g.nextPage());} // Fin de la boucle d'affichage de la page écran.
  
void Affiche_valeur_angulaire(int Valeur) {
  if (Valeur == 0)  u8g.print(' '); if(abs(Valeur) < 10) u8g.print(' ');
  if (Valeur > 0)  u8g.print('+'); 
  u8g.print(Valeur); u8g.print(" degre");
  }
 
void CADRES() {u8g.drawFrame(0,0,128,13); u8g.drawFrame(0,12,128,52);} // Cadre TITRE et cadre données.
  
void Aff_TEXTE(byte X, byte Y, char TEXTE[]) {// Choisir Y=9 pour tous les titres.
  char Caractere; byte I = 0;
  while (Caractere !=0) {Caractere = TEXTE[I]; u8g.setPrintPos((I*6)+X, Y); I++; u8g.print(Caractere);}}






