
// >>> Il ne reste plus que 96 Octets de disponibles en mémoire de programme.
// >>> Si une modification importante de programme devait se faire, le moyen le plus simple pour
// >>> dégager une place significative de 236 octets consisterait à passer en remarque l'option
// >>> "case 'L' : {Lister_EEPROM(); break;}" dans la routine "Executer_posture_ou_apprentissage()".
// >>> En effet, lister le contenu de l'EEPROM n'est vraiment utile qu'en développement logiciel.

// NOTE : L'espace entre la PILE et le TAS est mesuré à 252 octets, à comparer avec les 263 annoncés
// Pour les variables locales. C'est en principe suffisant pour ne pas risquer une "collision de PILE".
// ATTENTION : Ces valeurs sont issues du programme personnel qui est plus imposant que celui-ci car j'y
//             corrige un problème spécifique à l'un de mes servomoteurs.

/* Programme issu de P6 qui complète les commandes et apporte les modifications suivantes :
   ----------------------------------------------------------------------------------------
   • En bas à gauche de l'écran de base dans un petit cadre est précisé l'état actuel de
     la motorisation : 'A' pour Actif et 'N' pour neutralisé.
   • L'écran de base pour la pince Fermée indique l'écart entre les mors, l'angle et la valeur de consigne.
   • Au lieu d'afficher le nombre de postures mémorisées, plus opérationnel l'écran de base affiche en haut
     à droite le n° de la dernière posture sauvegardée en EEPROM ce qui facilite la création d'un programme.
   • Analyseur syntaxique modifié pour accepter des commandes "vides" sur '+', '-', '.N' et 'j'.
   • Mise en place de la protection thermique sur le servomoteur de la PINCE.
     Si pince "suspendue" l'écran de base affiche '*' en inverse en haut à droite.
   • Implantation de l'ARRET D'URGENCE par interruption et le réarmement avec 'A'.
   • 'b' Revient à l'affichage de l'écran de Base de la posture actuelle et réveil éventuel de l'afficheur.
   • 'd' : Démarrer le système. C'est l'inverse de QUITTER. Rétablit les consignes moteurs supposés OFF.
   • 'g' : Fait passer en mode graphique. (Sortie du mode par la commande 'b'.
   • 'j' : Jalonner les divers écrans. (Passe d'un écran à l'autre en permutation rétrograde.)
   • 'l' Alterne entre Mouvements Lent OUI / NON, (Déplacements progressifs par pas d'un degré.)
     Gère sur D12 une LED jaune qui signale "Mouvements Rapides" pour prévenir l'opérateur.
     En bas à gauche de l'écran de base dans un petit cadre est précisé l'état actuel de
     la motorisation : 'L' pour Lente et 'R' pour Rapide.
     (L'ouverture et la fermeture de la pince sont toujours rapides même en option "Mouvements lents".
   • 't' Initialise et sauvegarde en EEPROM la temporisation entre deux pas lents, (Pas de 1 degré.)
   • La liste des postures mémorisée se faisant avec 'u' est maintenant effectuée sur l'afficheur OLED.
   • 'p' : Puissance sur les moteurs OUI/NON. (Disjoncteur à relais électromécanique.)
   • 'q' : Comme pour 'Q' fait quitter le programme en configuration "propre".

   • '!' : Les valeurs des commandes de déplacement sont données en CONSIGNES.
      ATTENTION : Les déplacements sont rapides, donc cette commande allume la LED Jaune qui
                  retrouve son état à la sortie du mode. (Commande de type OUI/NON.)
      Potentiellement très risqué pour la motorisation, durant ce mode la LED rouge d'ARRET D'URGENCE
      clignote à environ 5Hz.     
   • '*' : Réautorise l'usage de la PINCE après une surchauffe.
   • '&' Affiche la page écran des limites angulaires et des consignes sur ligne USB. 
   • '=' : Rappel des valeurs de 't', 'T', Debut et de Fin sur la ligne USB.
   • '?' : Affiche les valeurs des paramètres du programme N. Erreur 9 si posture de type "BIP".
           Si mode APPRENTISSAGE indique sur la ligne USB le nombre actuel de postures apprises.
   • ' ' : Configure la posture en mode "Rétracté pince ouverte".
   • '>' : Active ou suspend le mode APPRENTISSAGE. (Si armé : Clignotement de la LED verte.)
   • '<' : Efface une posture d'un APPRENTISSAGE de façon inconditionnelle.
           Efface la dernière posture si pas de paramètre ou paramètre nul.
   • '/' : Commande qui inverse le sens d'exploration avec 'j'.
   • '$' : Liste toutes les POSTURES sur la ligne USB du Moniteur de l'IDE.
   • 'w' : Liste les postures de la séquence APPRISE.
         
   • 'A' : Arme le système après un ARRET D'URGENCE.
   • 'B' : Enregistre une posture de type  BIP.
   • 'D' : Posture de Début d'une séquence automatique.
   • 'E' : Exécute la séquence automatique N. (Si Motor ON.) Si le mode APPRENTISSAGE est actif, passe
           en exécution de la séquence apprise à condition que le déclenchement soit armé par ':'.
      Durant l'exécution une LED bleue s'illumine attestant du mode. (Utile si les moteurs sont OFF.)
   • 'F' : Posture de Fin d'une séquence automatique.
   • 'G' : Comme pour 'g' fait passer en mode graphique. (Sortie du mode par la commande 'b'.
   • 'I' : Insère la posture actuelle dans le programme d'APPRENTISSAGE.    
   • 'K' : Efface le programme N. (Ne fait qu'invalider le PGM et conserve Debut et Fin.)
   • 'L' : Liste le contenu de l'EEPROM sur la ligne USB du moniteur d'Arduino.
   • 'M' : Mémorise en EEPROM une Posture particulière.
   • 'P' : Purge intégralement l'EEPROM et initialise des données de base. (Exige N = 1024.)
   • 'Q' : QUITTER. (Même effet que 'q';)
   • 'R' : Restitue la posture particulière.   
   • 'S' : Impose un écart entre les deux mors et une page graphique montre la configuration de la pince
           et précise l'angle d'ouverture et l'Ecart entre les deux mors avec les ressorts supposés
           pratiquement comprimés.
   • 'U' : Liste sur la ligne USB les programmes actuellement effectifs.
   • 'V' : Valide en EEPROM le programme désigné par N.
   • 'x' : Place la Pince au plus bas possible.
   • 'X' : Coude et Epaule horizontaux. (Élongation maximale du bras.)
   • 'Z' : Efface toutes les postures et les cinq séquences de programmes. Impose l'argument N = 50
           Si mode APPRENTISSAGE efface l'intégralité du programme actuellement appris.
 
   UTILISER LE PROGRAMME : Frapper une chaine de caractères sur la ligne USB au format présenté dans les
         pages centrale du manuel d'utilisation. (Effet de la commande et plages des valeurs numériques.)

   Erreur 1 : Chaîne inférieure à un caractère. (Donc uniquement la validation.)
   Erreur 2 : Caractère de commande invalide.
   Erreur 3 : Consigne de position angulaire hors de la fourchette du moteur concerné.
   Erreur 4 : Num de la posture hors de la fourchette [1 à 50].
   Erreur 5 : Tenter de restituer une posture non validée.
   Erreur 6 : Commande 'Z' non suivie de la valeur 50 en mode "posture".
   Erreur 7 : Commande '?', 'E', 'K' et 'V' hors fourchette [1 à 5].
   Erreur 8 : Tenter de valider un programme dont Fin est NON supérieure à Debut.
   Erreur 9 : Tenter de réaliser un programme non valide.
   Erreur 10 : Commande '<' avec paramètre négatif ou supérieur au nombre actuel de postures.
   Erreur 11 : Déclencher une séquence dont les postures ne sont pas toutes valides.  
   Erreur 12 : Indiquer une valeur de ralentissement hors fourchette [10 à 30].
   Erreur 13 : Commande 'a' hors limite [0 à 4].
   Erreur 14 : En mode Incrémental tentative de sortir des limites de serrage de la pince.  
   Erreur 15 : Ouverture de la pince inférieure à 1 ou > 42. (Ecart donné en mm.)
   Erreur 16 : Commande 'i' hors limite [1 à 50].
   Erreur 17 : Utiliser '*' ou lorsque l'on rétablit les moteurs avec 'n' alors que la pince est en surchauffe.
   Erreur 18 : Utiliser f', 'o' et 'S' en mode "commandes par CONSIGNES".
   Erreur 19 : Tenter 'E' ou ')' alors que la PINCE est en sécurité thermique.
   Erreur 20 : Tenter 'E' alors que la fonction n'a pas été "armée" avec la commande ':'.
   Erreur 21 : Commande 'B' avec N pointant une posture actuellement valide.
   Erreur 22 : Mémoire APPRENTISSAGE saturée.
   Erreur 23 : Commandes 'P' non suivie de 1024.
   Erreur 24 : Commande 'E' ou '<' sur une séquence APPRENTISSAGE VIDE.
   Erreur 25 : Commande 'Z' non suivie de 60 en mode APPRENTISSAGE.
   Erreur 26 : Commande 'IN' interdite en mode APPRENTISSAGE, programme "vide" ou saturé,
               ou encore valeur de N < 1 ou supérieure au nombre actueld'enregistrements.
   
   BRANCHEMENTS à effectuer :
   --------------------------
   Moteur de la HANCHE sur le statif sur S15, moteur de l'EPAULE sur S0,
   moteur du COUDE sur S4, moteur de la PINCE sur S8.
   
   Le BUZZER actif est branché sur D2.
   Le bouton poussoir d'ARRET D'URGENCE se branche sur D3.
   La LED Verte pour le mode APPRENTISSAGE est câblée sur D5.
   La LED bicolore couleur Rouge "Moteurs actifs" est branché sur D7.
   La LED bicolore couleur Verte "Moteurs neutralisés" est branché sur D9.
   La LED Jaune qui signale "Moteurs RAPIDES" est câblée sur D12.
   Pilotage du DISJONCTEUR sur D13.

   La LED Rouge pour signaler un arrêt d'urgence est câblée sur A0.
   Le capteur de température pince est branché sur A1.
   Un connecteur est relié à A3 pour brancher un potentiomètre durant certains essais, ou
      le relais de "sécurité thermique active" si cette option est désirée.
   SDA est branché sur A4.  SCL est branché sur A5.
   La tension de puissance moteurs est amenée par le pont de résistances en A7.

                                                                PGM               RAM dynamique
 Occupation mémoire de cette version du programme :      30624 Octets (99%)      1727 Octets (84%)
 
----------------------- Déclarations pour le matériel --------------------------    */
#include <Wire.h> // Gère les protocole I2C sur A4 et A5.
#include <EEPROM.h>
#include "U8glib.h"
U8GLIB_SH1106_128X64 u8g(U8G_I2C_OPT_NONE);	// Usage de la ligne I2C (Two Wire Interface)
#include <Adafruit_PWMServoDriver.h>
Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver();

//----------------------- Définition des broches d'E/S -------------------------
#define BUZZER 2 // Le bruiteur est piloté par la sortie binaire D2.
#define Broche_URGENCE 3 // D3 sera une broche d'interruption. (Déclenché par transition négative.)
#define PGM_en_deroulement 4 // D4 : LED bleue qui s'allume durant une séquence programmée automatique.
#define LED_Verte 5 // LED verte pour le mode APPRENTISSAGE sur la sortie binaire D5.
#define LED_Moteur_ON 7 // LED (Double) Rouge qui signale que les moteurs sont actifs.
#define LED_Moteur_OFF 9 // LED (Double) Verte qui signale que les moteurs sont neutralisés.
#define LED_Mvt_Rapides 12 // LED Jaune qui signale "Moteurs RAPIDES".
#define DISJONCTEUR 13 // Disjoncteur. (Coupe ou rétablit la puissance électrique.)

#define LED_URGENCE 14 // A0 : LED Rouge pour signaler un arrêt d'urgence.
#define Entree_thermistance 15 // A1 : Entrée de mesure sur le capteur thermique.
#define Relais_thermique 17 // A3 : Option de coupure énergie sur le servomoteur de la PINCE.
#define Entree_Alim_moteurs 21 // A7 : Entrée analogique A7 utilisée pour mesurer la tension de puissance.

//-------------------------- Constantes du programme ---------------------------
#define Version_PGM "15-11-2019"    //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#define Calibre_U_moteurs 5.7 // Calibrage du diviseur potentiométrique d'entrée. @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#define Calibre_U_Thermistance 4.57 // Calibrage du pont diviseur de la thermistance. @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#define Limite_U_capteur 1.77 // Seuil de déclenchement thermique. (38°C) @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#define Seuil_avertissement 1.85 // Seuil d'avertissement thermique. (36°C) @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#define Position_Seuil 82 // Position_Seuil = 22 + ((Température seuil-33) * 12) @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#define Position_Seuil_sur_GRAPH 110 //Position_Seuil_sur_GRAPH = 65 + ((Température seuil-33) * 9) @@@@@@@@@@@@@@@@

//-------------------- Paramétrage des servomoteurs -------------------*
#define Pos_m_P 30   // Position angulaire minimale pour la PINCE.     *
#define Pos_M_P 90   // Position angulaire Maximale pour la PINCE.     *   Définir dans cette section
#define Csn_m_P 373  // Consigne minimale pour la PINCE.               *   de code les limites angulaires
#define Csn_M_P 264  // Consigne Maximale pour la PINCE.               *   et les valeurs de consignes
#define Pos_m_C -40  // Position angulaire minimale pour le COUDE.     *   correspondantes pour satisfaire
#define Pos_M_C 99   // Position angulaire Maximale pour le COUDE.     *   les spécificités des servomoteurs
#define Csn_m_C 224  // Consigne minimale pour le COUDE.               *   employés sur le bras manipulateur.
#define Csn_M_C 471  // Consigne Maximale pour le COUDE.               *
#define Pos_m_E 0    // Position angulaire minimale pour l'EPAULE.     *   NOTE : Bien que pour le coude il
#define Pos_M_E 90   // Position angulaire Maximale pour l'EPAULE.     *          serait possible d'aller jusqu'à
#define Csn_m_E 375  // Consigne minimale pour l'EPAULE.               *          100° en rétractation du bras,
#define Csn_M_E 215  // Consigne Maximale pour l'EPAULE.               *          on adopte 99 pour faciliter
#define Pos_m_H -90  // Position angulaire minimale pour la HANCHE.    *          la mise présentation de PAGE6.
#define Pos_M_H 90   // Position angulaire Maximale pour la HANCHE.    *
#define Csn_m_H 439  // Consigne minimale pour la HANCHE.              *
#define Csn_M_H 89   // Consigne Maximale pour la HANCHE.              *
//---------------------------------------------------------------------*
#define LGR_chaine 7 // Longueur maximale de la chaine de dialogue.
const byte TailleTexte = LGR_chaine + 1; // Taille réservée pour LGR_MAX plus le délimiteur.

//--------------------------- Variables du programme ---------------------------
boolean Ecran_en_veille;
boolean Executer_APPRENTISSAGE_valide;
boolean Interruption_Active;
boolean Liste_APPRENTISSAGE;
boolean Mode_Apprentissage;
boolean Mode_automatique;
boolean Mode_Graphique;
boolean Mode_incremental;
boolean Moteurs_ON;
boolean Mouvements_lents; // Mouvements gradués degré par degré.
boolean Ouverte;
boolean PGM_Valide;
boolean Pince_active;
boolean Pince_au_plus_bas;
boolean Positions_en_consignes;
boolean Prevenu_Tmp;
boolean Execute_APPRENTISSAGE_en_cours;
boolean Sens_Jalon_plus;
boolean Sens_plus;
boolean Urgence_clignote;

char Angle_Serrage_Pince;
char Caractere;
char Coude;
char Dernier_caractere; // Contiendra le dernier caractère de commande si "Valider" seule est utilisée.
char Epaule;
char Hanche;

byte Compteur_caracteres;
byte Debut; // Début du PGM (1 à 5] en EEPROM.
byte Dernier_SAV;
byte Fin; // // Fin du PGM (1 à 5] en EEPROM.
byte Increment;
byte Index_APPRENTISSAGE; // Pointe le premier emplacement libre en EEPROM d'APPRENTISSAGE.
byte Mode_AFF;
byte Moteur_incremente;
byte Nb_Postures;
byte num_ERR;
byte num_Posture_affichee;
byte PGM_actuel;
byte Position_curseur;

int Consigne; // Contient l'équivalent consigne servomoteur en fonction de Valeur_Numerique.
int Consigne_Coude;
int Consigne_Epaule;
int Consigne_Hanche;
int Consigne_min, Consigne_MAX;
int Consigne_Pince;
int Index_listage;
int Position_min, Position_MAX;
int Valeur_Numerique; // Contient la transformée numérique d'une chaine.
int PTR;
int Ralentissement; // Délai pour les mouvements gradués.

float Ecart; // Distance entre les deux pinces.
float U_Thermistance, Temperature;
unsigned long Temps_Ecoule_depuis_RESET = 0;

char Chaine_Memorisee[TailleTexte]; // Tampon mémoire pour la chaine entrante.
//------------------------------------------------------------------------------

void URGENCE() {
  detachInterrupt(1); // Interdire immédiatement les Interruptions pour parer les faux rebonds.
  Moteurs_ON = false; Traite_LEDs_Moteurs(); digitalWrite(DISJONCTEUR, LOW); BIP(); Eteindre_les_LEDs();
  Positions_en_consignes = false; Urgence_clignote = false; Mode_Graphique = false; Mode_Apprentissage = false;
  digitalWrite(LED_URGENCE, HIGH); Mode_AFF = 99; Executer_APPRENTISSAGE_valide = false;
  Interruption_Active = true;}

void Armer_apres_URGENCE() {
  digitalWrite(LED_URGENCE, LOW); Interruption_Active = false; attachInterrupt (1,URGENCE,LOW);
  Traite_LEDs_Moteurs();}

void setup() {
  u8g.setFont(u8g_font_6x10); // Pocice de matrices de 6x10 pixels lettres MJA/min comprises.
  pwm.begin(); // Initialise le module multiplexeur.
  pwm.setPWMFreq(50); // Fréquence de la PWM : En standard 50Hz pour des servomoteurs.  
  pinMode(BUZZER, OUTPUT); digitalWrite(BUZZER, LOW); pinMode(LED_Verte, OUTPUT);
  pinMode(LED_Moteur_ON, OUTPUT); pinMode(LED_Moteur_OFF, OUTPUT);
  pinMode(LED_Mvt_Rapides, OUTPUT); digitalWrite(LED_Mvt_Rapides, HIGH);
  pinMode(DISJONCTEUR, OUTPUT); digitalWrite(DISJONCTEUR, LOW);
  pinMode(LED_URGENCE, OUTPUT); digitalWrite(LED_URGENCE, LOW); pinMode(Broche_URGENCE, INPUT_PULLUP);
  pinMode(PGM_en_deroulement, OUTPUT); digitalWrite(PGM_en_deroulement, LOW);
  pinMode(Relais_thermique, OUTPUT); digitalWrite(Relais_thermique, LOW);
  attachInterrupt (1,URGENCE,LOW); Interruption_Active = false; Executer_APPRENTISSAGE_valide = false;
  Mode_Graphique = false; Sens_Jalon_plus = true; PGM_actuel = 1; Moteurs_ON = false; Traite_LEDs_Moteurs();
  PTR = 14; Index_APPRENTISSAGE = Lire_un_Octet_en_EEPROM();
  Serial.begin(115200); Serial.println(); Serial.print("Version du "); Serial.println(Version_PGM);
  Serial.println(); Index_listage = 1; num_Posture_affichee = 50; // Pour commencer à la n°1 si '$' seul.
  Moteur_incremente = 1; Increment = 1; Mode_automatique = false; Pince_active = true; 
  PTR = 505; Ralentissement = Lire_un_Entier_en_EEPROM();  Prevenu_Tmp = false;
  Debut = 0; Fin = 0; Ecran_en_veille = false; u8g.sleepOff(); // Active l'écran;
  Mouvements_lents = false; Retracte_le_bras_manipulateur(); Mouvements_lents = true; MAJ_LED_Mvt_Lent();
  Positions_en_consignes = false; Urgence_clignote = false; Calcule_Nb_Postures();
  Angle_Serrage_Pince = 60; Ecart = 31; // Initialisation impérative pour ces deux variables.
  Dernier_SAV = 0; Mode_incremental = false; Mode_AFF = 1; 
  // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  // Il faut passer case 'L' en remarque dans void Traite_Consigne() pour avoir assez de place.
  //@@@@@@@@@@@@@ Ci-dessous code ajouté pour afficher la place disponible. @@@@@@@@@@@
  // u8g.firstPage(); do {u8g.setPrintPos(22, 35); u8g.print("PILE - TAS = ");
  // u8g.print(SRAM_LIBRE());} while(u8g.nextPage()); while(!Serial.available());
  // Ci dessus : Tant que USB non activée : Ne rien faire. (Attendre la frappe d'un caractère au clavier.
  //@@@@@@@@@@@@@ ******************************************************** @@@@@@@@@@@@
  PAGE1();} // Pas vraiment utile, mais conservé pour simplifier la mesure de la place disponible.
  
  //@@@@@@@@@@@@@@ Ci-dessous fonction pour afficher la place disponible @@@@@@@@@@@@@@
  //int SRAM_LIBRE() { // Fonction qui retourne la taille de SRAM disponible.
  //extern int __heap_start, *__brkval; // Déclaration des deux pointeurs dédiés.
  //byte BIDON; // Dernière variable allouée, donc occupe le "haut" du TAS.
  //if (__brkval == 0) {return (int) &BIDON -(int) &__heap_start;}
  //else {return (int) &BIDON -(int) __brkval;}}
  //@@@@@@@@@@@@@@ ***************************************************** @@@@@@@@@@@@@@

void loop() {Attendre_une_chaine(); Analyseur_syntaxique();}  // Traite la consigne.
  
//==================================================================================
void Afficher_Ecran_actuel() {
  if (Mode_Graphique) PAGE6(); 
  else {switch(Mode_AFF) {
        case  1 :  {PAGE1(); break;} // Affichage de base.
        case  2 :  {PAGE2(); break;} // Affichage du mode incrémental.
        case  3 :  {PAGE3(); break;} // Affichage du mode Programmation.
        case  4 :  {PAGE4(); break;} // Liste les programmes valides en EEPROM.
        case  5 :  {PAGE5(); break;} // Affiche la page d'état de la motorisation.
        case  6 :  {PAGE6(); break;} // Affiche la page GRAPHIQUE dans commande 'j'.
        case  7 :  {PAGE7(); break;} // Affiche graphiquement la configuration PINCE.
        case  8 :  {PAGE8(); break;} // Affiche la page "SECURITE".
        case 98 : {PAGE_Securite_Pince(); break;} // Page si disjonction puissance déclenchée.
        case 99 : PAGE_URGENCE();}}} // Page d'urgence si sortie d'un programme interrompu.

//======================= Gestion des séquences automatiques =======================
void Place_INDEX_sur_PGM_EPROM(byte PGM) {// PGM compris entre [1 et 5].
 PTR = 506 + (PGM * 3); PGM_Valide = Lire_un_Octet_en_EEPROM();} // Laisse PTR sur l'entier DEBUT.

void Determine_Debut_Fin_de_PGM_Actuel() {
  Place_INDEX_sur_PGM_EPROM(PGM_actuel);
  Debut = Lire_un_Octet_en_EEPROM(); Fin = Lire_un_Octet_en_EEPROM();}

void Affiche_Debut_Fin_sur_USB() {
  Serial.print(">>>> DEBUT en  "); Serial.println(Debut);
  Serial.print(">>>> FIN en "); Serial.println(Fin);}

void Ecrire_boolean_true_en_EEPROM() {Ecrire_un_Octet_en_EEPROM(true);}

void Valide_en_EEPROM_le_PGM_N() {
  Verifie_1_a_5();
  if(num_ERR == 0) {
     PGM_actuel = Valeur_Numerique;
     if (Fin <= Debut) {num_ERR = 8; Affiche_Debut_Fin_sur_USB();} // Vérifie que Début est inférieur à Fin.
     // Valide le PGM actuellement traité :
     if(num_ERR == 0) {
        Place_INDEX_sur_PGM_EPROM(PGM_actuel); PTR--; Ecrire_boolean_true_en_EEPROM(); 
        Ecrire_un_Octet_en_EEPROM(Debut); Ecrire_un_Octet_en_EEPROM(Fin); Mode_AFF = 3;}}}

void Verifie_1_a_5() {if ((Valeur_Numerique < 1) || (Valeur_Numerique > 5)) num_ERR = 7;}

void Efface_le_programme_N() {
  Verifie_1_a_5();
  if(num_ERR == 0) {Place_INDEX_sur_PGM_EPROM(Valeur_Numerique); PTR--; Ecrire_un_Octet_en_EEPROM(false);}
  Mode_AFF = 3;}

void Verifie_1_a_50() {if ((Valeur_Numerique < 1) || (Valeur_Numerique > 50)) num_ERR = 4;}

void Debut_du_PGM_N() {
  Verifie_1_a_50(); if(num_ERR == 0) {Debut = Valeur_Numerique; Affiche_Debut_Fin_sur_USB();}}

void Fin_du_PGM_N() {
  Verifie_1_a_50(); if(num_ERR == 0) {Fin = Valeur_Numerique; Affiche_Debut_Fin_sur_USB();}}

void Positionne_PTR_en_fonction_de_Num() {PTR = 514; PTR = PTR + (10 * Valeur_Numerique);}
     // Les postures commencent en adresse relative 524.

void Prevenir_temperature() {
  if (!Prevenu_Tmp) 
     {Serial.println(); Serial.print("ATTENTION : Tmp > 36"); Degre(); Serial.println('C');
      BIP(); Prevenu_Tmp = true;}}

void Execute_le_PGM_N() {// Exécute l'une des 5 séquences de postures potentielle.
  byte Pointeur;
  Verifie_1_a_5();
  if(num_ERR == 0) {
    PGM_actuel = Valeur_Numerique;
    Place_INDEX_sur_PGM_EPROM(Valeur_Numerique); // Positionne le booléen "PGM_Valide".
    if(!PGM_Valide) num_ERR = 9; // Vérifier que le programme est validé en EEPROM.
    if(num_ERR == 0) {
    //---------- Vérifier que toutes les postures du programme sont valides. ----------
    Determine_Debut_Fin_de_PGM_Actuel(); Fin++; Pointeur = Debut; Valeur_Numerique = Debut;
    Positionne_PTR_en_fonction_de_Num();
    while ((num_ERR == 0) && (Pointeur < Fin)) {
          if (!Lire_un_Octet_en_EEPROM()) num_ERR = 11; PTR = PTR + 9; Pointeur++;}
    //---------------------------------------------------------------------------------
    if (num_ERR == 0) {// Si tout est correct déclencher la séquence automatique.
        digitalWrite(PGM_en_deroulement, HIGH); Mode_automatique = true;
        Determine_Debut_Fin_de_PGM_Actuel();
        //++++++++++++++++++++++++ Dérouler le programme enregistré en EEPROM. ++++++++++++++++++++++++
        for (byte I = Debut; I < Fin+1; I++) {
             if(Tension_capteur_temperature() < Seuil_avertissement) Prevenir_temperature();
             // Commence par vérifier que le servomoteur PINCE ne surchauffe pas :
             if(Tension_capteur_temperature() < Limite_U_capteur)
               {Passer_en_securite_pince(); I=100;} // PAGE_Securite_Pince et I=100 force la sortie de boucle
             // Si non surchauffe exécuter l'instruction suivante du programme :
             else {Position_curseur = I; // Réutilisation de la variable globale pour afficher l'état du processus.
                   if (Mode_Graphique) PAGE6(); else PAGE3();
                   Valeur_Numerique = I; Traite_Restitution();
                   if(Interruption_Active) I=100;}} // Sortir du programme si URGENCE activé.
        //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        if (Interruption_Active) Mode_AFF = 98;
        digitalWrite(PGM_en_deroulement, LOW);}}}
    else {Mode_AFF = 4;}
    Mode_automatique = false;}
//==================================================================================

float Tension_Alim_des_moteurs() {return analogRead(Entree_Alim_moteurs) * Calibre_U_moteurs / 1023;}

float Tension_capteur_temperature() {return analogRead(Entree_thermistance) * Calibre_U_Thermistance / 1023;}

void Traite_LEDs_Moteurs() {
  if (Moteurs_ON) {digitalWrite(LED_Moteur_ON, HIGH); digitalWrite(LED_Moteur_OFF, LOW);}
  else {digitalWrite(LED_Moteur_ON, LOW); digitalWrite(LED_Moteur_OFF, HIGH);}}

void Traite_Pince(int Consigne) {
  if (Pince_active) {
      digitalWrite(Relais_thermique, LOW); delay(200); pwm.setPWM(8,0,Consigne);
      delay(1000); if (Ouverte)digitalWrite(Relais_thermique, HIGH);}
  else  num_ERR = 17;}
  
void Neutralise_les_moteurs() {
  Moteurs_ON = ! Moteurs_ON; Traite_LEDs_Moteurs();
  if (Moteurs_ON) {
      pwm.setPWM(4,0, Consigne_Coude); pwm.setPWM(0,0, Consigne_Epaule);
      pwm.setPWM(15,0, Consigne_Hanche); pwm.setPWM(8,0, Consigne_Pince);}}
  
void Noyau_Quitter_Reprendre() {
  Mouvements_lents = true; MAJ_LED_Mvt_Lent(); Retracte_le_bras_manipulateur();
  Caractere = 'o'; Traite_Consigne(); Traite_LEDs_Moteurs();}

void DEBUTER() {
  // Reprend la configuration rétractée du bras manipulateur.
  // Force l'ouverture de la pince pour éviter tout mouvement à la reprise des activités.
  u8g.sleepOff(); Ecran_en_veille = false; Moteurs_ON = true; digitalWrite(DISJONCTEUR, HIGH);
  Noyau_Quitter_Reprendre(); attachInterrupt (1,URGENCE,LOW);} // Impératif de réarmer le B.P. "URGENCE" car si
  // sur URGENCE on sort avec 'Q' ou 'q' le retour avec 'd' semble OK mais URGENCE ne sera plus détecté.

void Eteindre_les_LEDs() {
  digitalWrite(LED_Mvt_Rapides,LOW); digitalWrite(LED_Moteur_OFF,LOW); digitalWrite(LED_Moteur_ON,LOW);}
  
void QUITTER() {
  // Place le bras manipulateur en configuration rétractée.
  // Force l'ouverture de la pince ne pas contracter en permanence le ressorts.
  Positions_en_consignes = false; Urgence_clignote = false; digitalWrite(LED_URGENCE,LOW);
  digitalWrite(Relais_thermique, LOW);
  digitalWrite(DISJONCTEUR, HIGH); delay(200); u8g.sleepOn(); Ecran_en_veille = true; // Écran OLED forcé en veille.
  Moteurs_ON = true; Noyau_Quitter_Reprendre(); Mode_Apprentissage = false;
  Moteurs_ON = false; digitalWrite(DISJONCTEUR, LOW); Eteindre_les_LEDs();}

void Calcule_les_limites_servomoteurs(byte Articulation) {// 1 Serrage, 2 Coude, 3 Epaule, 4 Hanche.
  switch (Articulation) {
     case 1 : {Position_min = Pos_m_P; Position_MAX = Pos_M_P;
               Consigne_min = Csn_m_P; Consigne_MAX = Csn_M_P; break;}
     case 2 : {Position_min = Pos_m_C; Position_MAX = Pos_M_C;
               Consigne_min = Csn_m_C; Consigne_MAX = Csn_M_C; break;}
     case 3 : {Position_min = Pos_m_E; Position_MAX = Pos_M_E;
               Consigne_min = Csn_m_E; Consigne_MAX = Csn_M_E; break;}
     case 4 : {Position_min = Pos_m_H; Position_MAX = Pos_M_H;
               Consigne_min = Csn_m_H; Consigne_MAX = Csn_M_H;}}
  if ((Valeur_Numerique > Position_MAX) || (Valeur_Numerique < Position_min)) {num_ERR = 3; Limites_sur_USB();}}

void Calcule_la_consigne_moteur(byte Articulation) {// 1 Serrage, 2 Coude, 3 Epaule, 4 Hanche.
  Calcule_les_limites_servomoteurs(Articulation);
  if(num_ERR == 0) {Position_curseur = map(Valeur_Numerique, Position_min, Position_MAX, 9, 118);
     Consigne = map(Valeur_Numerique, Position_min, Position_MAX, Consigne_min, Consigne_MAX);}}

void Positionne_un_moteur_en_mode_CONSIGNE(byte Articulation) {
  // Les déplacements sont obligatoirement en mouvements rapides.
  Consigne = Valeur_Numerique;
  if ((Caractere == 'o') || (Caractere == 'f') || (Caractere == 'S')) num_ERR = 18;
  else {switch (Articulation) {// Consigne_initiale = orientation actuelle de l'articulation.
            case 1 : {pwm.setPWM(8,0, Consigne); Consigne_Pince = Consigne; break;}
            case 2 : {pwm.setPWM(4,0, Consigne); Consigne_Coude = Consigne; break;}
            case 3 : {pwm.setPWM(0,0, Consigne); Consigne_Epaule = Consigne; break;}
            case 4 : pwm.setPWM(15,0, Consigne); Consigne_Hanche = Consigne;}}}

void Oriente_une_articulation(byte Articulation) {         
  // 1 : Pince, 2 Coude, 3 Epaule, 4 Hanche.
  byte Sortie;
  if (Caractere == 'o') Valeur_Numerique = 90;
  if ((Caractere == 'f') || (Caractere == 'S')) Valeur_Numerique = Angle_Serrage_Pince;
  Calcule_la_consigne_moteur(Articulation);
  if (num_ERR == 0) {
     if (Caractere == 's') {Ouverte = false; Angle_Serrage_Pince = Valeur_Numerique;}
     switch (Articulation) {
        case 1 : {if (Ouverte) Consigne_Pince = Csn_M_P; else Consigne_Pince = Consigne; Sortie = 8; break;}
        case 2 : {Coude = Valeur_Numerique; Consigne_Coude = Consigne; Sortie = 4; break;}
        case 3 : {Epaule = Valeur_Numerique; Consigne_Epaule = Consigne; Sortie = 0; break;}
        case 4 : Hanche = Valeur_Numerique; Consigne_Hanche = Consigne; Sortie = 15;}
     if (Moteurs_ON) {if (Sortie == 8) Traite_Pince(Consigne); else pwm.setPWM(Sortie,0, Consigne);}}}

void Bouger(byte Articulation) {Oriente_une_articulation(Articulation); delay(Ralentissement);}

void Positionne_un_moteur_si_NON_IRQ(byte Articulation) { // 1 Pince, 2 Coude, 3 Epaule, 4 Hanche.
  boolean Sauter; char Consigne_initiale; int Orientation_desiree;
  Sauter = false; Orientation_desiree = Valeur_Numerique;
  switch (Articulation) {// Consigne_initiale = orientation actuelle de l'articulation.
        case 1 : {Consigne_initiale = 90; break;}
        case 2 : {Consigne_initiale = Coude; Caractere = 'c'; break;}
        case 3 : {Consigne_initiale = Epaule; Caractere = 'e';break;}
        case 4 : Consigne_initiale = Hanche; Caractere = 'h';}
  if ((Caractere == 'o') || (Caractere == 'f') || (Caractere == 's') || (Caractere == 'S')) Sauter = true;
  if ((Mouvements_lents) && (!Sauter)){ // Ci-dessus : test pour mouvements lents sauf pour la pince.
       Calcule_les_limites_servomoteurs(Articulation);  
       if (num_ERR == 0) {
           digitalWrite(PGM_en_deroulement, HIGH);
           while (Consigne_initiale < Orientation_desiree) {
                 Consigne_initiale++; Valeur_Numerique = Consigne_initiale; Bouger(Articulation);}
           while (Consigne_initiale > Orientation_desiree) {
                 Consigne_initiale--; Valeur_Numerique = Consigne_initiale; Bouger(Articulation);}}
           if (!Mode_automatique) digitalWrite(PGM_en_deroulement, LOW);}
  else Oriente_une_articulation(Articulation);}

void Positionne_un_moteur(byte Articulation) {
  if (!Interruption_Active) {
     if (Positions_en_consignes) Positionne_un_moteur_en_mode_CONSIGNE(Articulation);
     else Positionne_un_moteur_si_NON_IRQ(Articulation);}}

void Restitue_la_posture_particuliere() {PTR = 495; Restitue_posture_de_PTR(); Mode_AFF = 1;}

void Restitue_posture_de_PTR() {
  Ouverte = Lire_un_Octet_en_EEPROM(); Angle_Serrage_Pince = Lire_un_Octet_en_EEPROM();
  // Ouvrir ou fermer doit être placé avant les mouvements de façon à agir sur la pince lorsque
  // le bras est en configuration correspondant à une posture de dépose ou de soulèvement.
  if (Ouverte) Caractere = 'o'; else Caractere = 'f'; Traite_Consigne();
  if (!Execute_APPRENTISSAGE_en_cours) PTR++; // Sauter le boolen "Faire un BIP"; 
  Valeur_Numerique = Lire_un_Entier_en_EEPROM(); Caractere = 'c'; Traite_Consigne();
  Valeur_Numerique = Lire_un_Entier_en_EEPROM(); Caractere = 'e'; Traite_Consigne();
  Valeur_Numerique = Lire_un_Entier_en_EEPROM(); Caractere = 'h'; Traite_Consigne();}

void Traite_Restitution() {
  Verifie_1_a_50();
  if (num_ERR == 0) {           
     Positionne_PTR_en_fonction_de_Num(); // Pointe le début de la posture.
     if (!Lire_un_Octet_en_EEPROM()) num_ERR = 5; // Vérifie que la posture n'est pas vide.
     if (num_ERR == 0) {
         //------------------ Traite l'instruction "Faire un BIP" ------------------
         PTR = PTR + 2; // Pointer le booléen du "BIP".
         if(Lire_un_Octet_en_EEPROM()) {BIP(); delay(1000);}
         //------------------------------------------------------------------------- 
         else {PTR = PTR - 3; Restitue_posture_de_PTR();}}}}

void Gere_le_mode_incremental() {// Commande 'aN' pour désigner l'articulation incrémentée ou décrémentée.
  // 0 : Sortir du mode, 1 : Serrage, 2 : Coude, 3 : Epaule, 4 : Hanche.
  if ((Valeur_Numerique < 0) || (Valeur_Numerique > 4)) num_ERR = 13;
  if(num_ERR == 0) {
    Mode_incremental = (Valeur_Numerique != 0);
    if (Mode_incremental) {Moteur_incremente = Valeur_Numerique; Mode_AFF = 2;
       switch (Moteur_incremente) {
         case 1 : {Valeur_Numerique = 90; Angle_Serrage_Pince = 90; Position_curseur = 118; Ouverte = true; break;}
         case 2 : {Valeur_Numerique = Coude; break;}
         case 3 : {Valeur_Numerique = Epaule; break;}
         case 4 :  Valeur_Numerique = Hanche;}
       Calcule_la_consigne_moteur(Moteur_incremente);}}}

void Gere_la_valeur_incrementale() {
  Verifie_1_a_50(); if (num_ERR > 0) num_ERR = 16;
  else Increment = Valeur_Numerique; Mode_incremental = true; Mode_AFF = 2;}
  
void Effectue_un_pas() {
  boolean SAV_Lent; SAV_Lent = Mouvements_lents;
  Mode_incremental = true; Mode_AFF = 2;
    switch (Moteur_incremente) {
      case 1 : {Valeur_Numerique = Angle_Serrage_Pince; Ouverte = false; break;}
      case 2 : {Valeur_Numerique = Coude; break;}
      case 3 : {Valeur_Numerique = Epaule; break;}
      case 4 : Valeur_Numerique = Hanche;}
  if (Sens_plus) Valeur_Numerique = Valeur_Numerique + Increment;
            else Valeur_Numerique = Valeur_Numerique - Increment;
  if (Moteur_incremente == 1) // Mouvement sur la PINCE.
     if ((Valeur_Numerique < 30) || (Valeur_Numerique > 90)) num_ERR = 14;
     else {Angle_Serrage_Pince = Valeur_Numerique; Mouvements_lents = false;}
  if (num_ERR == 0) Positionne_un_moteur(Moteur_incremente);
  if ((Moteur_incremente == 1) && (num_ERR == 0)) Angle_Serrage_Pince = Valeur_Numerique;
  Mouvements_lents = SAV_Lent; MAJ_LED_Mvt_Lent();}

void MAJ_LED_Mvt_Lent() {
  if (Mouvements_lents) digitalWrite(LED_Mvt_Rapides, LOW);
  else digitalWrite(LED_Mvt_Rapides, HIGH);}

void Valeur_delai_en_mouvements_lents() {
  if ((Valeur_Numerique < 5) || (Valeur_Numerique > 30)) num_ERR = 12;
  if(num_ERR == 0) {Ralentissement = Valeur_Numerique; PTR = 505;
                    Ecrire_un_Entier_en_EEPROM(Ralentissement); Mode_AFF = 5;}}

void Traite_posture_BIP() {
  Verifie_1_a_50();
  if (num_ERR == 0) {
     // Vérifie si la posture est libre. (Non valide dans la liste 'u'.
     Positionne_PTR_en_fonction_de_Num(); // Pointe le début de la posture.
     if (Lire_un_Octet_en_EEPROM()) num_ERR = 21;
     else {PTR--; Ecrire_boolean_true_en_EEPROM(); Nb_Postures++;  // La posture est validée.
           PTR = PTR+2; Ecrire_boolean_true_en_EEPROM();}} // Fonction BIP validée.
  Mode_AFF = 4;}

void Calcule_Ecart() {Ecart = 40 * sin(radians(Angle_Serrage_Pince)) - 19,65; Ecart = Ecart * 2;}
// ATTENTION : Si dans le calcul on intègre le * 2 tout en parennthésant correctement, le
//             résultat donne systématiquement 130 !

void Ecart_ouverture_pince() {
  float Sinus;
  if ((Valeur_Numerique < 1) || (Valeur_Numerique > 42)) num_ERR = 15;
  if (num_ERR == 0) {
      Sinus = (float(Valeur_Numerique) / 80) + 0.49125; if (Sinus > 1) Sinus = 1; 
      Angle_Serrage_Pince = char(degrees(abs(asin(Sinus)))); Positionne_un_moteur(1);
      Calcule_Ecart(); Mode_AFF = 7;}}

void Affiche_les_valeurs_programme_1_a_5() {
  Verifie_1_a_5();
  if (num_ERR == 0) {
      PGM_actuel = Valeur_Numerique; Place_INDEX_sur_PGM_EPROM(Valeur_Numerique);
      if(!PGM_Valide) num_ERR = 9; // Vérifier que le programme est validé en EEPROM.
      if (num_ERR == 0) {PGM_actuel = Valeur_Numerique; Mode_AFF = 3;}}}

void Retracte_le_bras_manipulateur() {
  Valeur_Numerique = 99; Caractere = 'c'; Traite_Consigne();
  Valeur_Numerique = 90; Caractere = 'e'; Traite_Consigne();
  Valeur_Numerique = 0; Caractere = 'h'; Traite_Consigne();
  Caractere = 'o'; Traite_Consigne(); Mode_AFF = 1;}
  
void Mesurer_la_temperature() {
  U_Thermistance = Tension_capteur_temperature();
  Temperature = ((3.4233333 - U_Thermistance) / 0.04333333);}

//===================================== Procédures du mode APPRENTISSAGE =====================================
void Effacer_la_memoire_APPRENTISSAGE() {PTR = 14; Ecrire_un_Octet_en_EEPROM(1); Index_APPRENTISSAGE = 1;}

void Efface_le_PGM_APPRENTISSAGE_en_EEPROM() {
  if(Valeur_Numerique != 60) num_ERR = 25;
  if (num_ERR == 0) {Effacer_la_memoire_APPRENTISSAGE(); Mode_Apprentissage = false;}}

void Charge_les_donnees_pointees() {
  Ouverte = Lire_un_Octet_en_EEPROM(); Angle_Serrage_Pince = Lire_un_Octet_en_EEPROM();
  Coude = Lire_un_Entier_en_EEPROM(); Epaule = Lire_un_Entier_en_EEPROM(); Hanche = Lire_un_Entier_en_EEPROM();}

void MAJ_Index_APPRENTISSAGE_en_EEPROM() {PTR = 14; Ecrire_un_Octet_en_EEPROM(Index_APPRENTISSAGE);}
    
void Memorise_les_mouvements() {
    Ecrire_un_Entier_en_EEPROM(Coude); Ecrire_un_Entier_en_EEPROM(Epaule); Ecrire_un_Entier_en_EEPROM(Hanche);}
    
void Inscrire_les_donnes_en_APPRENTISSAGE() {
  Ecrire_un_Octet_en_EEPROM(Ouverte); Ecrire_un_Octet_en_EEPROM(Angle_Serrage_Pince);      
  Memorise_les_mouvements(); // Enregister des données.
  Index_APPRENTISSAGE++; MAJ_Index_APPRENTISSAGE_en_EEPROM();}
            
void Inserer_une_posture() {
  byte Octet; int Sentinelle;
  if ((Mode_Apprentissage) || (Index_APPRENTISSAGE == 1) || (Valeur_Numerique < 1) ||
      (Index_APPRENTISSAGE > 60) || (Valeur_Numerique > (Index_APPRENTISSAGE - 1))) num_ERR = 26;
  if (num_ERR == 0) {
      //========== Pousser la mémoire APPRENTISSAGEconcernée de huit Octets ==========
      Sentinelle = 7; Sentinelle = Sentinelle + (8 * Valeur_Numerique); PTR = 486;
      while (PTR > Sentinelle) {
             Octet = Lire_un_Octet_en_EEPROM(); PTR = PTR+7; Ecrire_un_Octet_en_EEPROM(Octet); PTR = PTR - 10;}
      //===================== Insérer la posture au bon endroit ======================
      PTR = Sentinelle; Inscrire_les_donnes_en_APPRENTISSAGE();}}

void Gere_APPRENTISSAGE() {// Index_APPRENTISSAGE contient l'ordre de la prochaine posture disponible.
  if (Mode_Apprentissage) {
      if (Index_APPRENTISSAGE > 60) num_ERR = 22;
      // ----------- Le mouvement a été effectué, il reste à enregistrer la posture qui en résulte -----------
      else {PTR = 7; PTR = PTR + (8 * Index_APPRENTISSAGE); // Début en 15 soit en 7 + (8 * Index).
            Inscrire_les_donnes_en_APPRENTISSAGE();}}}
      //------------------------------------------------------------------------------------------------------

void Effacer_la_derniere_posture_apprise() {// Index_APPRENTISSAGE  : Ordre de la prochaine posture disponible.
  byte Octet; int Sentinelle, PTR_Cible, PTR_Source;
  if (Index_APPRENTISSAGE == 1) num_ERR = 24;
  // Vérifier que la posture désignée existe :
  if ((Valeur_Numerique >= Index_APPRENTISSAGE) || (Valeur_Numerique < 0)) num_ERR = 10;
  if (num_ERR == 0) {
     Sentinelle = (Index_APPRENTISSAGE * 8) + 15;
     PTR_Cible = (Valeur_Numerique * 8) + 7; PTR_Source = PTR_Cible + 8;
     // Décaler les postures de 8 cellules vers le début :
     while (PTR_Source < Sentinelle) {
            PTR = PTR_Source; Octet = Lire_un_Octet_en_EEPROM(); PTR_Source++;
            PTR = PTR_Cible; Ecrire_un_Octet_en_EEPROM(Octet); PTR_Cible++;}
     Index_APPRENTISSAGE--; MAJ_Index_APPRENTISSAGE_en_EEPROM();}
  Liste_APPRENTISSAGE = true; Affiche_contenus_Postures();}

void Execute_PGM_APPRENTISSAGE() {
  byte Pointeur; Pointeur = 1;
  if (Index_APPRENTISSAGE < 2) num_ERR = 24; // Sortir si programme vide.
  else {if (!Executer_APPRENTISSAGE_valide) num_ERR = 20;
        else {digitalWrite(PGM_en_deroulement, HIGH); PTR = 15;
              Executer_APPRENTISSAGE_valide = false; // Pour ne pas que la LED bleue continue de clignoter.
              Execute_APPRENTISSAGE_en_cours = true;
              digitalWrite(LED_Verte,LOW); Mouvements_lents = true; MAJ_LED_Mvt_Lent();
              while (Pointeur < Index_APPRENTISSAGE) {num_ERR = 0;
                     Serial.println(); Serial.print(Pointeur);
                     if(Tension_capteur_temperature() < Seuil_avertissement) Prevenir_temperature();
                     // Commence par vérifier que le servomoteur PINCE ne surchauffe pas :
                     if(Tension_capteur_temperature() < Limite_U_capteur) Passer_en_securite_pince();
                     //Exécuter l'instruction suivante du programme :
                     Restitue_posture_de_PTR(); Pointeur++; PAGE6();
                     if(Interruption_Active) PTR = Index_APPRENTISSAGE;} // Sortir si B.P. URGENCE activé.
        if (Interruption_Active) Mode_AFF = 98;
        Execute_APPRENTISSAGE_en_cours = false; // Ne plus sauter le booléen "BIP".
        Serial.println(); Serial.print("FIN du PGM."); Serial.println(); Serial.println();}}
   digitalWrite(PGM_en_deroulement,LOW);}
    
//============================================================================================================

void Executer_PGM_posture_ou_PGM_apprentissagee() {
  Mode_Apprentissage = false;
  if (!Pince_active) num_ERR = 19;
  else {if (Valeur_Numerique > 0) Execute_le_PGM_N(); else Execute_PGM_APPRENTISSAGE();}}

void Degre() {Serial.print(char('°'));}

void Angle_sur_USB(int Angle) {// Impérativement un int pour tenir compte du signe.
  if (abs(Angle) < 10) ESP_sur_USB(); if (Angle >= 0) Serial.print('+');
  Serial.print(Angle); Degre(); ESP_sur_USB();}

void AFF_txt_PINCE() {Serial.print("Pince ");}

void Affiche_contenus_Postures() {
  boolean Ouverte, Valide, Type_BIP, APPR_VIDE; byte NB_Max; int Angle_P, Angle_C, Angle_E, Angle_H;
  NB_Max = 51; APPR_VIDE = false; //Serial.println();
  if (Liste_APPRENTISSAGE) {
      PTR = 14; Index_APPRENTISSAGE = Lire_un_Octet_en_EEPROM(); // Contient NB_posture + 1.
      NB_Max = Index_APPRENTISSAGE;
      APPR_VIDE = (Index_APPRENTISSAGE == 1); 
      Serial.print("APPRENTISSAGE : "); if (APPR_VIDE) Serial.print("VIDE.");}
  else Mode_AFF = 4;
  if (!APPR_VIDE) 
      for (num_Posture_affichee = 1; num_Posture_affichee < NB_Max; num_Posture_affichee++) {
           Valeur_Numerique = num_Posture_affichee;
           if (Liste_APPRENTISSAGE) {PTR = 7; PTR = PTR + (8 * Valeur_Numerique); Valide = true;}
           else {Positionne_PTR_en_fonction_de_Num(); Valide = Lire_un_Octet_en_EEPROM();}
           Ouverte = Lire_un_Octet_en_EEPROM(); Angle_P = Lire_un_Octet_en_EEPROM();
           if (Liste_APPRENTISSAGE) Type_BIP = false; else Type_BIP = Lire_un_Octet_en_EEPROM();
           Angle_C = Lire_un_Entier_en_EEPROM(); Angle_E = Lire_un_Entier_en_EEPROM();
           Angle_H = Lire_un_Entier_en_EEPROM(); Serial.println();
           // -----------------------------------------------------------------------------------------
           Serial.print("Posture "); if (num_Posture_affichee < 10) ESP_sur_USB();
           Serial.print(num_Posture_affichee); ESP_sur_USB(); Serial.print("Pince ");
           // -----------------------------------------------------------------------------------------
           if (!Valide) Serial.print("NON VALIDE.");
           else {if (Type_BIP) Serial.print("Type BIP.");
                 else {if (Ouverte) {Serial.print("Ouvrte (///)"); ESP_sur_USB();}
                       else {Serial.print("Fermee ("); if (Angle_P < 10) ESP_sur_USB();
                             Serial.print(Angle_P); Degre(); Serial.print(')'); ESP_sur_USB();}
                       Serial.print("C ="); Angle_sur_USB(Angle_C); Serial.print("E ="); Angle_sur_USB(Angle_E);
                       Serial.print("H ="); Angle_sur_USB(Angle_H);}}} Serial.println();}

void Affiche_delimiteur_sur_USB() {for (byte I = 1; I < 50; I++) Serial.print('='); Serial.println();}
  
void Affiche_les_donnees_sur_USB() {
  Serial.println(); Serial.println(); Affiche_delimiteur_sur_USB(); Serial.print(Index_APPRENTISSAGE-1);
  Serial.print(" Posture(s) APPRISE(s)."); Mesurer_la_temperature(); Serial.println();
  Serial.print("Angle de la Pince = "); Serial.print(byte(Angle_Serrage_Pince)); Degre(); Serial.println();
  Serial.print("Temperature du Servomoteur = "); Serial.print(Temperature,1); Degre(); Serial.println('C');
  Serial.print("Ralentissement : "); Serial.print(Ralentissement); Serial.println("mS");
  Serial.print("Increments de "); Serial.println(Increment);
  Affiche_Debut_Fin_sur_USB(); Affiche_delimiteur_sur_USB(); Serial.println();}

void Posture_pince_vers_le_le_bas(){
  Mode_AFF = 1; Serial.println(); Serial.println(); Affiche_delimiteur_sur_USB();
  if (Pince_au_plus_bas) Serial.println("Pince au plus bas :");
  else Serial.println("Coude et Epaule horizontaux :");
  Serial.println("Confirmer avec Oui SVP."); BIP(); Affiche_delimiteur_sur_USB(); Attendre_une_chaine();
  if (Caractere == 'O') {
      Valeur_Numerique = 0; if (Pince_au_plus_bas) Valeur_Numerique = Pos_m_C; Caractere = 'c';
      Traite_Consigne(); Valeur_Numerique = 0; Caractere = 'e'; Traite_Consigne();}
  else {Serial.println("ABANDON de la commande."); Serial.println();}}
  
void Traite_Consigne() {// Les commandes sont classées par ordre alphabétique.
  Mode_incremental = false; if ((Caractere != 'j') && (Caractere != '/')) Mode_AFF = 1;
  // Ci-dessous toute commande sauf ':' et 'E' stoppe l'option activée par ':'.
  if ((Caractere == 'E') || (Caractere == ':')) {} else Executer_APPRENTISSAGE_valide = false;
  switch (Caractere) {
    case '$' : {Liste_APPRENTISSAGE = false; Affiche_contenus_Postures(); break;}
    case ' ' : {Retracte_le_bras_manipulateur(); break;}
    case '*' : {if(Tension_capteur_temperature() <= Limite_U_capteur) num_ERR = 17; 
                else {Pince_active = true; digitalWrite(Relais_thermique, LOW); Prevenu_Tmp = false;} break;}
    case '&' : {Limites_sur_USB(); break;}
    case '!' : {Positions_en_consignes = !Positions_en_consignes;  Mode_AFF = 8; 
                if (Positions_en_consignes) {Urgence_clignote = true; digitalWrite(LED_Mvt_Rapides, HIGH);}
                else {Urgence_clignote = false;  MAJ_LED_Mvt_Lent(); digitalWrite(LED_URGENCE,LOW);} break;}
    case '+' : {Sens_plus = true; Effectue_un_pas(); break;}
    case '-' : {Sens_plus = false; Effectue_un_pas(); break;}
    case '=' : {Affiche_les_donnees_sur_USB(); break;}
    case '?' : {Affiche_les_valeurs_programme_1_a_5(); break;}
    case '/' : {Sens_Jalon_plus = !Sens_Jalon_plus;
                Caractere = 'j'; Traite_Consigne(); Dernier_caractere = 'j'; break;}
    case ':' : {Executer_APPRENTISSAGE_valide = true; break;}
    case '>' : {Mode_Apprentissage = !Mode_Apprentissage; break;}
    case '<' : {Effacer_la_derniere_posture_apprise(); break;}
    case 'a' : {if (Valeur_Numerique==0) Mode_AFF = 1; // Sort du mode INCREMENTAL.
                else Gere_le_mode_incremental(); break;} // Passe en mode INCREMENTAL.
    case 'A' : {Armer_apres_URGENCE(); break;}
    case 'b' : {Mode_AFF = 1; u8g.sleepOff(); Ecran_en_veille = false; Mode_Graphique = false; break;}
    case 'B' : {Traite_posture_BIP(); break;}
    case 'c' : {Positionne_un_moteur(2); Gere_APPRENTISSAGE(); break;} // Positionne le COUDE.
    case 'd' : {DEBUTER(); break;} // Reprendre les activités quand on a quitté.
    case 'D' : {Debut_du_PGM_N(); break;}
    case 'e' : {Positionne_un_moteur(3); Gere_APPRENTISSAGE(); break;} // Positionne le EPAULE.
    case 'E' : {Executer_PGM_posture_ou_PGM_apprentissagee(); break;} // Execute le PGM désigné.
    case 'f' : {Ouverte = false; Valeur_Numerique = Angle_Serrage_Pince; Positionne_un_moteur(1); break;}
    case 'F' : {Fin_du_PGM_N(); break;}
    case 'g' : {Mode_Graphique = true; break;}
    case 'G' : {Mode_Graphique = true; break;}
    case 'h' : {Positionne_un_moteur(4); Gere_APPRENTISSAGE(); break;} // Positionne la HANCHE.
    case 'i' : {Gere_la_valeur_incrementale(); break;} // Impose la valeur de l'incrément.
    case 'I' : {Inserer_une_posture(); break;} // Insère dans la mémoire APPRENTISSAGE.
    case 'j' : {Mode_Graphique = false;
                if (Sens_Jalon_plus) {if (Mode_AFF > 1) Mode_AFF--; else Mode_AFF = 8;}
                else {Mode_AFF++; if (Mode_AFF > 8) Mode_AFF = 1;} break;}
    case 'k' : {Kill_une_posture_en_EEPROM(); break;} //Effacer une posture.
    case 'K' : {Efface_le_programme_N(); Mode_AFF = 3; break;} // 'K' pour Kill comme pour les postures.
    case 'l' : {Mouvements_lents = !Mouvements_lents; Mode_AFF = 5; // Mouvements "Lents" OUI/NON. 
                MAJ_LED_Mvt_Lent(); break;}
    case 'L' : {Lister_EEPROM(); break;}
    case 'm' : {Memorise_la_posture_actuelle(); break;}
    case 'M' : {Memorise_une_posture_particuliere(); break;}
    case 'n' : {Neutralise_les_moteurs(); Mode_AFF = 5; break;}
    case 'o' : {Ouverte = true; Positionne_un_moteur(1); break;}
    case 'p' : {digitalWrite(DISJONCTEUR, !digitalRead(DISJONCTEUR)); delay(200); Mode_AFF = 5; break;} // P OUI/NON.
    case 'P' : {Purger_entierement_EEPROM(); break;}
    case 'q' : {QUITTER(); break;} // Laisser l'ensemble en configuration "propre".
    case 'Q' : {QUITTER(); break;} // MAJ ou min seront acceptées.
    case 'r' : {Traite_Restitution(); break;}
    case 'R' : {Restitue_la_posture_particuliere(); break;}
    case 's' : {if (Positions_en_consignes) {Positionne_un_moteur_en_mode_CONSIGNE(1); Mode_AFF = 1;}
                else {Positionne_un_moteur(1);
                      if (num_ERR == 0) {Angle_Serrage_Pince = Valeur_Numerique; Calcule_Ecart(); Mode_AFF = 7;}}
                break;} // Commande qui Ferme la pince à l'angle infiqué avec 's'.
    case 'S' : {Ecart_ouverture_pince(); break;}
    case 't' : {Valeur_delai_en_mouvements_lents(); break;}
    case 'u' : {Mode_AFF = 4; break;}
    case 'U' : {Mode_AFF = 3; break;}
    case 'v' : {Ecran_en_veille = ! Ecran_en_veille;  // Inverser l'état de "Ecran en veille".
                if (Ecran_en_veille) {Eteindre_les_LEDs(); u8g.sleepOn(); Mode_Apprentissage = false;}
                else {u8g.sleepOff(); MAJ_LED_Mvt_Lent(); Traite_LEDs_Moteurs();} break;}
    case 'V' : {Valide_en_EEPROM_le_PGM_N(); break;} // Valeur numérique de 1 à 5.
    case 'w' : {Liste_APPRENTISSAGE = true; Affiche_contenus_Postures(); break;}
    case 'x' : {Pince_au_plus_bas = true; Posture_pince_vers_le_le_bas(); break;}
    case 'X' : {Pince_au_plus_bas = false; Posture_pince_vers_le_le_bas(); break;}
    case 'Z' : {if (Mode_Apprentissage) Efface_le_PGM_APPRENTISSAGE_en_EEPROM();
                else Efface_toutes_les_postures_en_EEPROM(); break;}
    default : num_ERR = 2;}}

// ATTENTION : BIP() initialement utilisait delay(100); Mais la fonction de temporisation est
//             inopérante dans la routine d'interruption. Le délai pour obtenir l'équivalent
//             de 0,1S consiste à forcer à "1" 20000 fois la sortie BUZZER.
void BIP() {for (int I=0; I<20000; I++) {digitalWrite(BUZZER, HIGH);}; digitalWrite(BUZZER, LOW);}

void Passer_en_securite_pince() {
  Mode_Graphique = false;
  digitalWrite(Relais_thermique, HIGH); Pince_active = false; // Ne plus agir sur la pince jusqu'à la commande '*'.
  BIP(); Mode_AFF= 98; Moteurs_ON = false; Traite_LEDs_Moteurs();}
  
void Analyseur_syntaxique() {// Compteur_caracteres mis à jour par Attendre_une_chaine()
  int SAV_Valeur_Numerique; SAV_Valeur_Numerique = Valeur_Numerique;
  char SAV_Caractere;
  num_ERR = 0;
  if (Compteur_caracteres == 0) num_ERR = 1;
  if ((num_ERR == 1) && ((Dernier_caractere=='j') || (Dernier_caractere=='+') || (Dernier_caractere == '-')))
      {num_ERR = 0; Compteur_caracteres = 1; Caractere = Dernier_caractere;}
   SAV_Caractere = Caractere;
  //==================== Analyse de la commande =====================
  Traite_Consigne(); // Impérativement en premier car peut générer l'erreur 3, l'erreur 4 ...
  Serial.print("Commande "); Serial.print(SAV_Caractere); Serial.print(SAV_Valeur_Numerique);
  if (num_ERR == 0) Serial.println(" !OK!");
  else {BIP(); Serial.print(" !ERR "); Serial.print(num_ERR); Serial.println("!");}}

void Attendre_une_chaine() {
  boolean FINI; char Caractere_lu;
  FINI = false; Compteur_caracteres=0; // Si FIFO non vide lire les caractères :
  while(!FINI) {
  //============== Traite le clignotement des LEDs (Verte et rouge) ==============
  if (millis() - Temps_Ecoule_depuis_RESET > 100)  {
     Temps_Ecoule_depuis_RESET = millis();
     if (Executer_APPRENTISSAGE_valide) digitalWrite(PGM_en_deroulement, !digitalRead(PGM_en_deroulement));
     if (Mode_Apprentissage) digitalWrite(LED_Verte, !digitalRead(LED_Verte)); else digitalWrite(LED_Verte,LOW);
     if (Urgence_clignote) digitalWrite(LED_URGENCE, !digitalRead(LED_URGENCE));}
  //==============================================================================
  if(Tension_capteur_temperature() < Seuil_avertissement) Prevenir_temperature();
  if((Tension_capteur_temperature() < Limite_U_capteur) && Pince_active) Passer_en_securite_pince();
  Afficher_Ecran_actuel(); // Rafraichissement de l'écran durant l'attente d'une commande sur la ligne USB.
  //==============================================================================
  if (Serial.available()) {Caractere_lu = Serial.read();
      if (Caractere_lu == char(13)) FINI = true; // char (13) est le LF de "Valider". (Sentinelle.)
      if ((Compteur_caracteres < (LGR_chaine)) && (!FINI))
         {Chaine_Memorisee[Compteur_caracteres] = Caractere_lu; Compteur_caracteres++;
          delay(5);}}} // Délai impératif.
  Chaine_Memorisee[Compteur_caracteres] = '\0'; // Placer le délimiteur de fin de texte.
  Caractere = char(Chaine_Memorisee[0]);
  if (Compteur_caracteres>0) Dernier_caractere = Caractere;
  // Extraire le nombre. En sortie Valeur_Numerique contiendra le nombre dans la chaine
  // ou 00 si le texte n'est pas "numérique" : 
  for(byte J = 0; J < Compteur_caracteres; J++)
      Chaine_Memorisee[J] = Chaine_Memorisee[J+1]; // Enlève le caractère de contrôle. 
  Valeur_Numerique = atoi(Chaine_Memorisee);}
  
//--------------------------- Routines de gestion EEPROMe ---------------------------

byte Lire_un_Octet_en_EEPROM() {PTR++; return eeprom_read_byte((unsigned char*) PTR - 1);}
     
int Lire_un_Entier_en_EEPROM() {PTR= PTR + 2; return eeprom_read_word((unsigned int*) (PTR - 2));}

void Ecrire_un_Octet_en_EEPROM(byte Octet) {eeprom_write_byte((unsigned char*) PTR, Octet); PTR++;}

void Ecrire_un_Entier_en_EEPROM(int Entier)
     {eeprom_write_word((unsigned int*) PTR, Entier); PTR= PTR + 2;}

void Calcule_Nb_Postures() {
  Nb_Postures = 0;
  PTR = 524;
  while (PTR < 1023) {if (Lire_un_Octet_en_EEPROM()) Nb_Postures++; PTR = PTR + 9;}}

void Ecrire_Octet_EEPROM(int ADRESSE, byte Octet) {eeprom_write_byte((unsigned char*) ADRESSE, Octet);}
  
void Purger_entierement_EEPROM() {
  if(Valeur_Numerique != 1024) num_ERR = 23;
  if (num_ERR == 0) {
      PTR=0; do Ecrire_un_Octet_en_EEPROM(255); while(PTR < 525) ; // Remplit l'EEPROM avec des $FF.
      do Ecrire_un_Octet_en_EEPROM(0); while(PTR < 1024) ; // Efface les postures et "imposer BIP = faux".
      PTR = 505; Ecrire_un_Entier_en_EEPROM(30); PTR++; PTR++; // Initialise 't' et saute deux Octets.
      // Valider le premier programme avec Debut =1 et Fin = 2 :
      Ecrire_un_Octet_en_EEPROM(1); Ecrire_un_Octet_en_EEPROM(1); Ecrire_un_Octet_en_EEPROM(2);
      // La posture PARTICULIERE est initialisée avec la posture de rétractation du bras :
      Caractere = ' '; Traite_Consigne(); Caractere = 'M'; Traite_Consigne();
      // Les deux postures du programme sont initialisées avec la posture de rétractation du bras :
      Valeur_Numerique = 1; Caractere = 'm'; Traite_Consigne();
      Valeur_Numerique = 2; Caractere = 'm'; Traite_Consigne();    
      Nb_Postures = 2; // Met à jour le nombre de postures valides en EEPROM.  
      Mode_Apprentissage = false; Effacer_la_memoire_APPRENTISSAGE(); // Vider entièrement l'APPRENTISSAGE.
      u8g.firstPage(); do {// Début de la boucle d'affichage de la page écran.
      Aff_TEXTE(48,28,"EEPROM"); Aff_TEXTE(30,40,"INITIALISEE.");}
      while(u8g.nextPage()); // Fin de la boucle d'affichage de la page écran.
      BIP(); delay(500); BIP(); delay(500); BIP(); while(!Serial.available());}}
      // Ci dessus : Tant que USB non activée : Ne rien faire. (Attendre la frappe d'un caractère au clavier.

void Efface_toutes_les_postures_en_EEPROM() {// Efface aussi les cinq programmes.
  if(Valeur_Numerique != 50) num_ERR = 6;
  if (num_ERR == 0) { // Mettre des $00 partout efface également les "fonctions BIP".
      for (int I=509; I < 1024; I++) Ecrire_Octet_EEPROM(I, 00); Nb_Postures = 0; PGM_actuel = 0;} Mode_AFF = 4;}

void Memorise_posture_en_PTR() {
    Ecrire_un_Octet_en_EEPROM(Ouverte); Ecrire_un_Octet_en_EEPROM(Angle_Serrage_Pince);
    Ecrire_un_Octet_en_EEPROM(false); // Force à faux le boolen "Faire un BIP" pour valider les mouvements.
    Memorise_les_mouvements();}
    
void Memorise_une_posture_particuliere() {PTR = 495; Memorise_posture_en_PTR(); Mode_AFF = 1;}      
     
void Memorise_la_posture_actuelle() {
  Verifie_1_a_50();
  if (num_ERR == 0) {
      Dernier_SAV = Valeur_Numerique; Positionne_PTR_en_fonction_de_Num(); // Pointe le début de la posture NN.
      Ecrire_boolean_true_en_EEPROM(); // Valide la posture.
      Memorise_posture_en_PTR(); // Mémorise les paramètres de configuration de la posture.
      Calcule_Nb_Postures(); }}
     
void Kill_une_posture_en_EEPROM() {// Ne fait que forcer à "00 le premier octet du groupe.
  Verifie_1_a_50(); Positionne_PTR_en_fonction_de_Num(); // Pointe le début de la posture.
  if (num_ERR == 0) {Ecrire_un_Octet_en_EEPROM(0); Calcule_Nb_Postures(); Mode_AFF = 4;}}
  
//-----------------------------------------------------------------------------------
void ESP_sur_USB() {Serial.print(' ');}

void Lister_EEPROM() {
  PTR = 0;
  Lister_un_BLOC();Lister_un_BLOC();
  Lister_un_BLOC();Lister_un_BLOC(); } 
void Lister_un_BLOC() {
  Serial.println(); // Faire une séparation toutes les "page mémoire".
  byte Compteur_lignes = 0;
  while (Compteur_lignes < 16)
    {Lister_une_LIGNE(); Compteur_lignes++; } }
void Lister_une_LIGNE() {   
  byte Compteur_Octets = 0; ESP_sur_USB();
  if (PTR<10) {Serial.print('0');};
  if (PTR<100) {Serial.print('0');};
  if (PTR<1000) {Serial.print('0');};
  Serial.print(PTR); ESP_sur_USB(); ESP_sur_USB();  
  while (Compteur_Octets < 16) {
    Lister_OCTET(); Compteur_Octets++; }
  Serial.println(); }
void Lister_OCTET() {
  byte octet = Lire_un_Octet_en_EEPROM();
  if (octet < 16) Serial.print('0'); 
  Serial.print(octet,HEX); ESP_sur_USB();}

//-----------------------------------------------------------------------------------

void Encadrement() {u8g.drawFrame(0,0,128,64);}

void CADRES() {Encadrement(); u8g.drawHLine(0,12,128);} // Cadre TITRE et cadre données.

void Aff_TEXTE(byte X, byte Y, char TEXTE[]) {// Choisir Y=9 pour tous les titres.
  char Caractere; byte I = 0; Caractere = 'x'; // 'x' pour ne pas avoir 0 en entrée de boucle.
  while (Caractere !=0) {Caractere = TEXTE[I]; u8g.setPrintPos((I*6)+X, Y); I++; u8g.print(Caractere);}}

void Espace() {u8g.print(' ');}
  
void Affiche_valeur_angulaire(int Valeur) {
  if (!Positions_en_consignes) {
     if (Valeur == 0)  Espace(); if(abs(Valeur) < 10) Espace(); if (Valeur > 0)  u8g.print('+'); 
     u8g.print(Valeur); if (!Mode_incremental) u8g.print(" (");}
  else u8g.print(" (");}
  
void PAGE1() {// Écran de base.
  u8g.firstPage(); do {// Début de la boucle d'affichage de la page écran.
  CADRES(); u8g.drawVLine(85,0,12 ); Aff_TEXTE(8, 10 ,"Etat du BRAS  Sv"); u8g.setPrintPos(109,10);
  if (Dernier_SAV==0) u8g.print("--"); else u8g.print(Dernier_SAV); Aff_TEXTE(23,22,"PINCE :");
  if (Ouverte) Aff_TEXTE(72, 22,"Ouverte");
  else {u8g.setPrintPos(71, 22); Affiche_valeur_angulaire(Angle_Serrage_Pince);
        u8g.print(Consigne_Pince); u8g.print(')');}
  Aff_TEXTE(11,31,"Serrage : "); if (Ouverte) u8g.print("///"); else {u8g.print(Ecart,1); u8g.print(" mm");} 
  Aff_TEXTE(23,41,"COUDE :"); u8g.setPrintPos(71, 41); Affiche_valeur_angulaire(Coude);
  u8g.print(Consigne_Coude); u8g.print(')'); Aff_TEXTE(11,51," EPAULE :"); u8g.setPrintPos(71, 51);
  Affiche_valeur_angulaire(Epaule); u8g.print(Consigne_Epaule); u8g.print(')');
  Aff_TEXTE(11,61," HANCHE :"); u8g.setPrintPos(71, 61); Affiche_valeur_angulaire(Hanche);
  u8g.print(Consigne_Hanche); u8g.print(')'); u8g.drawHLine(1,51,10 );
  u8g.drawVLine(10,52,11); u8g.setPrintPos(3, 61);
  if (Moteurs_ON) u8g.print('A'); else u8g.print('N');
  u8g.drawHLine(1,39,10 ); u8g.drawVLine(10,40,11); u8g.setPrintPos(3, 49);
  if (Mouvements_lents) u8g.print('L'); else u8g.print('R');
  if (!Pince_active) {
      u8g.drawBox(117,13,10,11); u8g.setColorIndex(0); u8g.setPrintPos(120, 22);
      u8g.print('*'); u8g.drawVLine(122,15,7);} u8g.setColorIndex(1);}
  //====================================================================
  while(u8g.nextPage());} // Fin de la boucle d'affichage de la page écran.

void PAGE2() {// Affichage en mode "Mouvements par Incréments".
  //====================================================================
  u8g.firstPage(); do {// Début de la boucle d'affichage de la page écran.
  CADRES(); Aff_TEXTE(21, 10 ,"INCREMENTS de");  u8g.setPrintPos(103,10); u8g.print(Increment);
  Aff_TEXTE(21, 22 ,"Moteur :"); u8g.setPrintPos(76, 22);
  switch (Moteur_incremente) {
    case 1 : {u8g.print("Serrage"); break;}
    case 2 : {u8g.print("Coude"); break;}
    case 3 : {u8g.print("Epaule"); break;}
    case 4 : u8g.print("Hanche");}
  Aff_TEXTE(21, 35 ,"Consigne = "); u8g.setPrintPos(88,35);
  switch (Moteur_incremente) {
    case 1 : {u8g.print(Consigne_Pince); break;}
    case 2 : {u8g.print(Consigne_Coude); break;}
    case 3 : {u8g.print(Consigne_Epaule); break;}
    case 4 : u8g.print(Consigne_Hanche);}
  Aff_TEXTE(21, 48 ,"Position = "); u8g.setPrintPos(88,48); 
  switch (Moteur_incremente) {
    case 1 : {u8g.print(int(Angle_Serrage_Pince)); break;}
    case 2 : {Affiche_valeur_angulaire(Coude); break;}
    case 3 : {Affiche_valeur_angulaire(Epaule); break;}
    case 4 : Affiche_valeur_angulaire(Hanche);}
  u8g.drawHLine(1,25,126); u8g.drawHLine(1,38,126); u8g.drawHLine(1,51,126);
  // Tracer les rubans de représentation de la plage possible :
  u8g.drawBox(9,54,110,3);
  u8g.drawPixel(Position_curseur,57); u8g.drawPixel(Position_curseur,58);
  u8g.drawPixel(Position_curseur,59); u8g.drawPixel(Position_curseur,60);}
  //====================================================================
  while(u8g.nextPage());} // Fin de la boucle d'affichage de la page écran.

void PAGE3() {// Affiche les paramètres de la séquence de Posture actuellement validée.
  byte Longueur;
  //====================================================================
  u8g.firstPage(); do {// Début de la boucle d'affichage de la page écran.
  CADRES();
  if (Mode_automatique) {
      Longueur = map(Position_curseur, Debut, Fin, 1, 126); u8g.drawBox(1,4,Longueur,5);}
  else {Aff_TEXTE(8, 10 ,"PROGRAMME cible :"); u8g.setPrintPos(115, 10); u8g.print(PGM_actuel);}
  u8g.drawHLine(1,25,126); for (byte I=27; I<128; I=I+25) u8g.drawVLine(I,13,12);
  for (byte I=1; I<6; I++) {u8g.setPrintPos((25*I)-12, 22); Place_INDEX_sur_PGM_EPROM(I);
  if (PGM_Valide) u8g.print(I); else u8g.print('X');} Determine_Debut_Fin_de_PGM_Actuel();
  Aff_TEXTE(15, 36 ,"Debut "); u8g.print(Debut); u8g.print(" / Fin "); u8g.print(Fin);
  Aff_TEXTE(13, 47 ,"Ralentissement "); u8g.print(Ralentissement);
  if (Mode_automatique) {
      u8g.drawHLine(1,51,126); Aff_TEXTE(30, 61 ,"Posture > "); u8g.print(Position_curseur);}
  else {Aff_TEXTE(23, 58 ,"Nb postures "); u8g.print(Fin - Debut + 1);}}
  //====================================================================
  while(u8g.nextPage());} // Fin de la boucle d'affichage de la page écran.

void PAGE4() {// Liste l'état actuel de la zone des 50 Postures possibles.
  byte K; // Contiendra le n° de la posture.
  //====================================================================
  u8g.firstPage(); do {// Début de la boucle d'affichage de la page écran.
  K=1; PTR = 524; // les postures commencent à l'adresse relative 524.
  for (byte Ligne=8; Ligne<65; Ligne=Ligne+10) {
       for (byte X=0; X<120; X=X+14) {// Décale d'une position sur X.
            if (K < 51) {
                u8g.setPrintPos(X,Ligne);
                //--------------------------------------------------
                if (Lire_un_Octet_en_EEPROM()) // Laisse PTR sur "Pince ouverte".
                   {PTR= PTR + 2; // Sauter les deux paramètres de la PINCE.
                    if (Lire_un_Octet_en_EEPROM()) u8g.print("==");
                    else {if (K < 10) u8g.print('0'); u8g.print(K);}
                    PTR = PTR - 3;} // Rétablir le pointeur à "Valide + 1".
                else  u8g.print("  ");
                //--------------------------------------------------
                K++; PTR = PTR + 9;}}}
  u8g.print("  NB : "); u8g.print(Nb_Postures);}
  //====================================================================
  while(u8g.nextPage());} // Fin de la boucle d'affichage de la page écran.

void PAGE5() {// Présente l'état actuel et les paramètres relatifs à la motorisation.
  float U_motorisation; U_motorisation = Tension_Alim_des_moteurs();
  // NOTE : Il faut impérativement mesurer la valeur avant la boucle d'affichage car si on
  //        intègre cette mesure et que la valeur varie, l'affichage sera perturbé.
  //====================================================================
  u8g.firstPage(); do {// Début de la boucle d'affichage de la page écran.
  CADRES(); Aff_TEXTE(12, 10 ,"Etat MOTORISATION.");
  Aff_TEXTE(8,24,"Mouvements "); if (Mouvements_lents) u8g.print("Lents"); else u8g.print("Rapides");
  Aff_TEXTE(8,36,"Ralentissement : "); u8g.print(Ralentissement);
  Aff_TEXTE(8,48,"Moteurs : "); if (Moteurs_ON) u8g.print("Actifs"); else u8g.print("Suspendus"); 
  Aff_TEXTE(8,60,"U Moteurs : "); u8g.print(U_motorisation,1); u8g.print('v');}
  //====================================================================
  while(u8g.nextPage());} // Fin de la boucle d'affichage de la page écran.

void ESP_a_ESP() {Serial.print(" a ");}
void Ferme_plage() {Serial.println(')');}

void Limites_sur_USB() {// Rappels sur ligne USB des valeurs des butées logicielles sur les servomoteurs.
  Serial.println(); Affiche_delimiteur_sur_USB(); Serial.print("Version du "); Serial.println(Version_PGM);
  Serial.println("Ralentissement : 5mS a 30mS");
  Serial.print("1 Pince  [30 a 90]  ("); Serial.print(Csn_m_P);
  ESP_a_ESP(); Serial.print(Csn_M_P); Ferme_plage();
  Serial.print("2 Coude  [-40 a 99] ("); Serial.print(Csn_m_C);
  ESP_a_ESP(); Serial.print(Csn_M_C); Ferme_plage();
  Serial.print("3 Epaule [0 a 90]   ("); Serial.print(Csn_m_E);
  ESP_a_ESP(); Serial.print(Csn_M_E); Ferme_plage();
  Serial.print("4 Hanche [-90 a 90] ("); Serial.print(Csn_m_H);
  ESP_a_ESP(); Serial.print(Csn_M_H); Ferme_plage();
  Affiche_delimiteur_sur_USB();}

void PAGE6() {// Écran de représentation graphique du bras manipulateur.
  byte XD,YD; // X et Y du DEBUT d'un segment ou d'un point particulier dans les coordonnées de l'écran OLED.
  byte XF,YF; // X et Y de la FIN d'un segment.
  int Longueur_du_ruban; // Impérativement un int.
  //-------------- Calculs à effectuer impérativement avant la boucle d'affichage. --------------
  Mesurer_la_temperature();
  Longueur_du_ruban = int((Temperature - 33) * 9); // Si le calcul est négatif, le byte sera égal à zéro.
  if (Longueur_du_ruban < 0) Longueur_du_ruban = 1; // Conserver le test <.
  if(Temperature > 39.9) Longueur_du_ruban = 62; // Ne pas dépasser l'échelle si TH trop élevée.
  //====================================================================
  u8g.firstPage(); do {// Début de la boucle d'affichage de la page écran.
  //-------------------------- Tracer les invariants graphiques --------------------------
  Encadrement(); u8g.drawVLine(65,1,62);
  u8g.drawHLine(93,34,7); u8g.drawVLine(96,31,7);
  u8g.drawCircle(96,34,29,U8G_DRAW_UPPER_LEFT); u8g.drawCircle(96,34,29,U8G_DRAW_UPPER_RIGHT);
  u8g.drawVLine(67,35,3); u8g.drawVLine(125,35,3); u8g.drawHLine(67,38,59);
  u8g.drawCircle(72,7,4); u8g.drawHLine(70,7,5); // Tracer le cercle et le moins :
  u8g.drawCircle(120,7,4); u8g.drawHLine(118,7,5); u8g.drawVLine(120,5,5);  // Tracer le cercle et le plus :
  u8g.drawDisc(57,50,4); u8g.drawRBox(51,45,13,25,4);  // Trace l'articulation d'épaule.
  // Indiquer les angles :
  Aff_TEXTE(4,9,"C="); u8g.print(int(Coude)); Aff_TEXTE(69,48,"E="); u8g.print(int(Epaule));
  Aff_TEXTE(95,48,"H="); u8g.print(int(Hanche)); u8g.drawHLine(66,50,61); // Séparation des textes.
  // Tracer le thermomètre :
  for (byte X=74; X<121; X=X+9) u8g.drawVLine(X,52,4); // Tracer les graduations.
  u8g.drawVLine(Position_Seuil_sur_GRAPH,52,10); // Tracer le segment qui positionne le seuil thermique.
  //---------------------------- Fin des invariants graphiques ---------------------------
  u8g.drawBox(65,57,Longueur_du_ruban,3); // Tracé du "mercure" sur le thermomètre.
  // Tracer la vue de dessus :
  if (Hanche >= 0)  XF = 96 + abs(25 * (sin(radians(Hanche)))); else XF = 97 - abs(25 * (sin(radians(Hanche))));
  YF = 34 - abs(25 * (cos(radians(Hanche)))); u8g.drawLine(96,34,XF,YF); u8g.drawDisc(XF,YF,1);
  // Tracer l'Humérus :
  XD = 58; YD = 50; XF = 58 - abs(29 * (cos(radians(Epaule)))); YF = 50 - abs(29 * (sin(radians(Epaule))));
  u8g.drawDisc(XF,YF,2); u8g.drawLine(XD,YD,XF,YF);
  //Tracer le radius :
  XD = XF; YD = YF;
  if (Coude > 90) XF = XD + abs(16 * (cos(radians(Coude)))); else XF = XD - abs(16 * (cos(radians(Coude))));
  if (Coude >= 0) YF = YD - abs(17 * (sin(radians(Coude)))); else YF = YD + abs(17 * (sin(radians(Coude)))); 
  u8g.drawDisc(XF,YF,2); u8g.drawLine(XD,YD,XF,YF);
  // Tracer la PINCE :
  XD = XF-10; YD = YF-1; // (Intégrer directement dans les calculs conduit à une taille de code identique.)
  if (Ouverte) u8g.drawFrame(XD,YD,7,4); else u8g.drawBox(XD,YD,7,4); u8g.drawPixel(XF-3,YF);
  // Tracer le centre de l'articulation de l'épaule : (Placé impérativement à la fin des affichages.)
  u8g.setColorIndex(0); u8g.drawDisc(58,50,2); u8g.setColorIndex(1);}
  //====================================================================
  while(u8g.nextPage());} // Fin de la boucle d'affichage de la page écran.

void PAGE7() {// Présente graphiquement la posture actuelle de la pince.
  byte Hauteur, Position;
  Position = 112 - abs(20 * (cos(radians(Angle_Serrage_Pince))));
  Hauteur = 26 - abs(20 * (sin(radians(Angle_Serrage_Pince))));
  u8g.firstPage(); do {// Début de la boucle d'affichage de la page écran.
  //====================================================================
  Encadrement(); u8g.drawBox(112,26,15,12); u8g.drawDisc(112,26,2); 
  u8g.drawDisc(Position,Hauteur,2); u8g.drawDisc(112,37,2); u8g.drawDisc(Position,63-Hauteur,2);
  u8g.drawLine(112,26,Position,Hauteur); u8g.drawLine(112,37,Position,63-Hauteur);
  u8g.drawHLine(Position-10,Hauteur,10); u8g.drawHLine(Position-10,63-Hauteur,10);
  u8g.drawVLine(Position-10,Hauteur,6); u8g.drawVLine(Position-10,58-Hauteur,5);
  u8g.drawFrame(Position-30,Hauteur+6,21,9); u8g.drawFrame(Position-30,49-Hauteur,21,9);
  Aff_TEXTE(18, 14 ,"Angle"); u8g.setPrintPos(28,25); u8g.print(int(Angle_Serrage_Pince));
  Aff_TEXTE(19, 42 ,"Serre"); u8g.setPrintPos(17,52); if(Ecart < 10) u8g.print('0');  
  u8g.print(Ecart,1); u8g.print("mm"); u8g.drawFrame(12,30,46,28);}
  //====================================================================
  while(u8g.nextPage());} // Fin de la boucle d'affichage de la page écran.

void PAGE8() {// Affichage relatif aux divers paramètres gérant la sécurité matérielle.
    int Longueur_du_ruban; // Impérativement un int.
  Mesurer_la_temperature();
  // NOTE : Il faut impérativement évaluer les deux valeurs ci-avant avant la boucle d'affichage.
  //        En effet, si on intègre cette mesure dans la boucle d'affichage, l'écran sera perturbé.
  Longueur_du_ruban = int((Temperature - 33) * 12); // Si le calcul est négatif, le byte sera égal à zéro.
  if (Longueur_du_ruban < 0) Longueur_du_ruban = 1; // Conserver < zéro.
  if(Temperature > 39.9) Longueur_du_ruban = 84; // Ne pas dépasser l'échelle si TH trop élevée.
  //====================================================================
  u8g.firstPage(); do {// Début de la boucle d'affichage de la page écran.
  CADRES(); Aff_TEXTE(18, 10 ,"=== SECURITE ==="); Aff_TEXTE(8,23,">> CONSIGNES : ");
  if (!Positions_en_consignes) u8g.print("NON");
  else {u8g.drawBox(95,14,22,11); u8g.setColorIndex(0); u8g.print("OUI");u8g.setColorIndex(1);}
  //----------------- Tracé du ruban de température et du seuil -----------------
  u8g.drawFrame(0,26,128,14); u8g.drawVLine(22,27,12); u8g.drawVLine(106,27,12); 
  Aff_TEXTE(7,36,"33"); Aff_TEXTE(111,36,"40");
  for (byte X=34; X<107; X=X+12) u8g.drawVLine(X,27,4);
  u8g.drawVLine(Position_Seuil,27,12);
  u8g.drawBox(22,33,Longueur_du_ruban,4);
  //-----------------------------------------------------------------------------
  Aff_TEXTE(11,49,"Tmp : "); u8g.print(Temperature,1); u8g.print(" Celsius");
  Aff_TEXTE(8,59,"Capteur Tmp : "); u8g.print(U_Thermistance,2); u8g.print('v');}
  //====================================================================
  while(u8g.nextPage());} // Fin de la boucle d'affichage de la page écran.

void Reprise_avec_A() {Aff_TEXTE(12, 10 ,"REPRENDRE avec 'A'");}

void PAGE_INCIDENT(boolean URGENCE) {
  u8g.firstPage(); do {// Début de la boucle d'affichage de la page écran.
  u8g.drawFrame(8,17,112,26); Reprise_avec_A();
  if(URGENCE) Aff_TEXTE(43,33,"URGENCE !");
  else Aff_TEXTE(15,33,"Th moteur PINCE !");}
  while(u8g.nextPage());} // Fin de la boucle d'affichage de la page écran.
  
void PAGE_Securite_Pince() {PAGE_INCIDENT(false);}
 
void PAGE_URGENCE() {PAGE_INCIDENT(true);}


  
